# -*- coding: utf-8 -*-
"""
Created on Tue Feb  1 11:09:11 2022

@author: bpaqueletwuetz
"""

# -*- coding: utf-8 -*-
"""
Created on Thu Aug 12 09:47:47 2021

@author: TUD278249
"""
import numpy as np
from datetime import datetime
import matplotlib.gridspec as gridspec
import matplotlib.cm as cm
import matplotlib
import matplotlib.pyplot as plt
from scipy.optimize import curve_fit
from numpy import genfromtxt
from scipy import signal
import os
abspath = os.path.abspath(__file__)
dname = os.path.dirname(abspath)
os.chdir(dname)
from os import listdir
import csv

from os.path import isfile, join
if 'ds' in globals():
    del ds
counter = 0
for root, subdirectories, files in os.walk(dname):
    
    for  file in files:
        counter = counter + 1
        # print(os.path.join(root, file))
        # print(counter)
        if file.endswith('.csv') and counter == 1:
            ds = np.genfromtxt(os.path.join(root, file), delimiter=',')
            # print(os.path.join(root, file))
        elif file.endswith('.csv'):
            ds1 = np.genfromtxt(os.path.join(root, file), delimiter=',')
            ds = np.concatenate((ds,ds1),axis=1)
            print(os.path.join(root, file))
            
#%% set paramenters for all figures           
plt.rcParams['figure.dpi'] = 600 #Note: this is helpuful for high dpi displays such as 4k display on Windows
plt.rcParams['figure.autolayout'] = False
plt.rcParams['figure.constrained_layout.use'] = True
plt.rcParams['lines.markersize'] = 1
plt.rcParams['lines.linewidth'] = 1
plt.rcParams['font.size'] = 8
plt.rcParams['font.sans-serif'] = "Arial"
plt.rcParams['font.family'] = "sans-serif"
plt.rcParams['xtick.direction'] = 'in'
plt.rcParams['ytick.direction'] = 'in'
plt.rcParams['axes.facecolor'] = 'white'
plt.rcParams['pdf.fonttype'] = 42
plt.rcParams['ps.fonttype'] = 42
plt.rcParams['axes.linewidth'] = 1
plt.rcParams['mathtext.rm'] = 'Arial'
plt.rcParams['mathtext.it'] = 'Arial'
plt.rcParams['mathtext.default'] = 'it'
plt.rcParams['lines.color'] = 'black'
plt.rcParams['lines.linewidth'] = 1
plt.rcParams["legend.numpoints"] = 1
plt.rcParams["legend.frameon"] = False
#mpl.rcParams['figure.figsize'] = (4, 3)
plt.rcParams['font.size'] = 8
plt.rcParams['font.family'] = 'Arial'
plt.rcParams['figure.autolayout'] = True

# #Setting finally the Text characters to regular instead of italics.
plt.rcParams['mathtext.rm'] = 'Arial'                 #'custom''Arial' #custom make mu italic, Arial straight
plt.rcParams['mathtext.it'] = 'Arial: italic'         #make latex italics unless use \mathrm{}
plt.rcParams['mathtext.default'] = 'it'#'regular'
plt.rcParams['xtick.major.width'] = 0.8
plt.rcParams['ytick.major.width'] = 0.8
# plt.rcParams["errorbar.capsize"]= 3
plt.rcParams['savefig.bbox'] = 'tight' #to avoid clipping mask cropping the axis label    
cms = 1/2.54   
X_size = 3
#%% rearrange data

QT701 = ds[153:191,[2,5,8,11]]
QT710 = ds[0:90,[2,5,8,11]]
QT712 = ds[90:153,[2,5,8,11]]

QT701_min = QT701[[10,10+1+2,10+1+2+3+10,10+1+2+3+10+0+8],:]
# outcommented data: original dataset with 8 samples, one sample was omitted because of a strong TLF in the spectral range, which did not allow
# fitting a charge-noise-plane, the "real" dataset, omitted sample 7
# QT710_min = QT710[[3,3+5+8,3+5+8+1+12,3+5+8+1+12+3+11,3+5+8+1+12+3+11+3+8,3+5+8+1+12+3+11+3+8+2+4,3+5+8+1+12+3+11+3+8+2+4+5+12,3+5+8+1+12+3+11+3+8+2+4+5+12+4+8],:]
QT710_min = QT710[[3,3+5+8,3+5+8+1+12,3+5+8+1+12+3+11,3+5+8+1+12+3+11+3+8,3+5+8+1+12+3+11+3+8+2+4,3+5+8+1+12+3+11+3+8+2+4+5+12+4+8],:]
QT712_min = QT712[[4,4+5+7,4+5+7+3+19,4+5+7+3+19+3+8,4+5+7+3+19+3+8+2+10],:]


# device data from literature 

#1,2, Xue2022 Nature
#3,4,5,6,7,8 Philips2022 Nature, taken from fig2e

Data_literature = np.array([20.5,9.4,3.0,2.5,3.7,3.7,5.9,5.1,])
#1 Xue2022 Nature
Data_literature_CZ = np.array([99.5,])

#%% getting a cmap
import matplotlib.pyplot as plt
import matplotlib.colors as colors
import numpy as np

def truncate_colormap(cmap, minval=0.0, maxval=1.0, n=100):
    new_cmap = colors.LinearSegmentedColormap.from_list(
        'trunc({n},{a:.2f},{b:.2f})'.format(n=cmap.name, a=minval, b=maxval),
        cmap(np.linspace(minval, maxval, n)))
    return new_cmap

arr = np.linspace(0, 50, 100).reshape((10, 10))
fig, ax = plt.subplots(ncols=2)

cmap = plt.get_cmap('jet')
new_cmap = truncate_colormap(cmap, 0.1, 0.9)
ax[0].imshow(arr, interpolation='nearest', cmap=cmap)
ax[1].imshow(arr, interpolation='nearest', cmap=new_cmap)
plt.show()

colors = new_cmap(np.linspace(0.1,0.95,2))

colors = colors[::-1]

#%% plot data

charge_fidelity_1nm_cap = ds[:,2]
t2_1nm_cap = ds[:,5]

x = np.linspace(-0.2,-0.1,len(QT701_min))
x1 = np.linspace(-0.05,0.05,len(QT710_min))
x2 = np.linspace(0.1,0.2,len(QT712_min))
x3 = np.linspace(-0.2,-0.1,len(Data_literature))

cms = 1/2.54


fig = plt.figure(42,figsize=((8.6/2)*cms ,(8.6/1.1)*cms ),tight_layout = False,constrained_layout=True, dpi = 600)
ax1 = fig.subplots()
# ax1.tick_params(axis='both', direction='in')
fig.patch.set_facecolor('white')
color = 'black'
ax1.set_ylabel('$T_2^\star$ ($\mu$s)', color=color)
ax1.scatter(x,QT701_min[:,2]/1e3,c='black',marker= '*',s = 6, label='spin qubit')
ax1.scatter(x3,Data_literature,c='black',marker= 's',s = 6, label='spin qubit literature')
# ax1.scatter(x,QT701_min[:,3]/1e3,c='black',marker= '^',s = 3, label='singlet-triplet qubit')
ax1.scatter(x,QT701_min[:,1]/1e3,c='black',marker= 'o',s = 4, label='charge qubit')

ax1.plot(x,QT701_min[:,1]/1e3,c=colors[0],marker= 'o',lw = 0, markersize = 3)
# ax1.scatter(x,QT701_min[:,1]/1e3,c='red',marker= 'o',s = 5)
ax1.plot(x,QT701_min[:,2]/1e3,c=colors[0],marker= '*',lw = 0, markersize = 5)
# ax1.scatter(x,QT701_min[:,2]/1e3,c='red',marker= '*',s = 5)
# ax1.scatter(x,QT701_min[:,3]/1e3,c='red',marker= '^',s = 5)

# ax1.scatter(x1,QT710_min[:,1]/1e3,c='blue',marker= 'o',s = 5)
ax1.plot(x1,QT710_min[:,1]/1e3,c=colors[1],marker= 'o',lw = 0, markersize = 3)
# ax1.scatter(x1,QT710_min[:,2]/1e3,c='blue',marker= '*',s = 5)
ax1.plot(x1,QT710_min[:,2]/1e3,c=colors[1],marker= '*',lw = 0, markersize = 5)
# ax1.scatter(x1,QT710_min[:,3]/1e3,c='blue',marker= '^',s = 5)

ax1.plot(x2,QT712_min[:,1]/1e3,c='green',marker= 'o',lw = 0, markersize = 3)
ax1.plot(x2,QT712_min[:,2]/1e3,c='green',marker= '*',lw = 0, markersize = 5)
# ax1.scatter(x2,QT712_min[:,1]/1e3,c='green',marker= 'o',s = 5)
# ax1.scatter(x2,QT712_min[:,2]/1e3,c='green',marker= '*',s = 5)
# ax1.scatter(x2,QT712_min[:,3]/1e3,c='green',marker= '^',s = 5)
ax1.tick_params(axis='y', labelcolor=color)
ax1.set_yscale('log')
ax1.set_ylim([0.00001,100000/1e3])

plt.xticks([np.mean(x),np.mean(x1),np.mean(x2)], ['A','B','C'],  ha='center', rotation=0)

locmaj = matplotlib.ticker.LogLocator(base=10,numticks=12) 
ax1.yaxis.set_major_locator(locmaj)

plt.legend(loc= 'center left',fontsize = 6)

plt.tick_params(labelbottom=True, bottom = True, direction = 'in', width =0.8, top = False, right =False, length=4)  


plt.savefig(fname = 't2star.pdf',
        orientation='portrait', papertype=None, format=None,
        transparent=True, bbox_inches='tight',
        frameon=None, metadata=None)      
# ax2 = ax1.twinx()  # instantiate a second axes that shares the same x-axis

#%% plot data

fig = plt.figure(42,figsize=((8.6/2)*cms ,(8.6/1.1)*cms ),tight_layout = False,constrained_layout=True, dpi = 600)

ax2 = fig.subplots()
color = 'black'
ax2.set_yscale('log')
ax2.set_ylabel('sin', color=color)  # we already handled the x-label with ax1
# ax2.scatter(x,QT701_min[:,0],c='red',marker= 'o',s = 5)
# ax2.scatter(x1,QT710_min[:,0],c='blue',marker= 'o',s = 5)
# ax2.scatter(x2,QT712_min[:,0],c='green',marker= 'o',s = 5)

ax2.plot(x,QT701_min[:,0],c=colors[0],marker= 'o',lw = 0, markersize = 3)
ax2.plot(x1,QT710_min[:,0],c=colors[1],marker= 'o',lw = 0, markersize = 3)
ax2.plot(x2,QT712_min[:,0],c='green',marker= 'o',lw = 0, markersize = 3)

ax2.tick_params(axis='y', labelcolor=color)
ax2.set_ylim([1e-4,1e-2])
# ax2.set_yscale('log')

# fig.tight_layout()  # otherwise the right y-label is slightly clipped
plt.show()
plt.xticks([np.mean(x),np.mean(x1),np.mean(x2)], ['A','B','C'],  ha='center', rotation=0)

# cmap = plt.get_cmap('viridis')
# cb = plt.pcolormesh(VP, V_SD, I,cmap=cmap, rasterized=True, vmin=-2e-10, vmax=1e-10)
# cb = plt.pcolormesh(B[:,0:77], R[:,0:77], np.diff(I[:,0:78]),cmap=cmap, shading='nearest', rasterized=True,
#                     vmin = -5, vmax = 5)
plt.rcParams['savefig.dpi'] = 300
plt.rcParams['savefig.transparent'] = True
plt.rcParams['pdf.fonttype'] = 42
plt.rcParams.update({'font.sans-serif':'Arial'})
plt.rcParams.update({'font.size': 8})
# ax.set_xlabel('B (T)')
# ax.set_ylabel('E (mV)')
# plt.xlim(0,1.5)
# plt.ylim(0.8,1.2)
# plt.xlabel('V$_P$ (mV)')
plt.ylabel(r'1-$F_{CZ}$') 
# plt.colorbar(cb,label= 'I (nA)').ax.tick_params(axis='y', direction='in')
# fig.savefig('theory_dummy.png', transparent=True, facecolor='w')

# plt.savefig(fname = 'fidelity.pdf',
#         orientation='portrait', papertype=None, format=None,
#         transparent=True, bbox_inches='tight',
#         frameon=None, metadata=None)    
